"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var path_1 = require("path");
var fs_1 = require("rxline/fs");
var sdh_1 = require("@connectv/sdh");
var content_1 = require("./content");
var namespace_1 = require("./namespace");
var post_1 = require("../components/page/meta-override/post");
function rebuild(files, config, builder, assets, webpackConfig) {
    var _this = this;
    var _ogstyles = assets.styles.theme.registry.toString();
    return new Promise(function (resolve) {
        files
            .peek(function (file) { return console.log("" + chalk_1.default.gray('# rebuilding ........ ' + path_1.join(file.root, file.path))); })
            .pipe(fs_1.readFile(), content_1.content(builder, assets.toc, config, assets.styles), sdh_1.post(assets.bundle.collect()), sdh_1.post(namespace_1.namespace(config)), sdh_1.post(post_1.pageSpecificMeta), function (file) {
            (config.page.post || []).forEach(function (p) { return file.content.post(function (html) { return p(html, file, config); }); });
            return file;
        }, fs_1.mapExt(function () { return '.html'; }), fs_1.mapRoot(function () { return config.dest.html; }), sdh_1.save())
            .peek(function (file) { return console.log("" + chalk_1.default.green('#') + chalk_1.default.gray(' rebuilt:: .........') + " " + path_1.join(file.root, file.path)); })
            .process()
            .collect(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(assets.styles.theme.registry.toString() !== _ogstyles)) return [3 /*break*/, 2];
                        console.log("" + chalk_1.default.gray('# rebuilding ........ ' + assets.styles.path));
                        return [4 /*yield*/, assets.styles.save()];
                    case 1:
                        _a.sent();
                        console.log(chalk_1.default.green('#') + " " + chalk_1.default.gray('rebuilt:: .........') + " " + assets.styles.path);
                        _a.label = 2;
                    case 2:
                        if (!assets.bundle.repack) return [3 /*break*/, 4];
                        console.log("" + chalk_1.default.gray('# rebuilding ........ ' + assets.bundle.path));
                        return [4 /*yield*/, sdh_1.save(assets.bundle, webpackConfig)];
                    case 3:
                        _a.sent();
                        assets.bundle.repack = false;
                        console.log(chalk_1.default.green('#') + " " + chalk_1.default.gray('rebuilt:: .........') + " " + assets.bundle.path);
                        _a.label = 4;
                    case 4:
                        resolve(assets);
                        return [2 /*return*/];
                }
            });
        }); });
    });
}
exports.rebuild = rebuild;
//# sourceMappingURL=rebuild.js.map